#    Kye - classic puzzle game
#    Copyright (C) 2005, 2006 Colin Phipps <cph@moria.org.uk>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

class KMoveInput:
    def __init__(self):
	self.currentkey = None
	self.keyqueue = []
	self.mousemoving = None
	self.currentmouse = None

    keymap = {
	0xff51	: ("rel",-1, 0),
	0xff53	: ("rel", 1, 0),
	0xff52	: ("rel", 0,-1),
	0xff54	: ("rel", 0, 1),
	}

    def key_press_event(self, widget, event):
	try:
            pressedkey =  KMoveInput.keymap[event.keyval]
            # If this key is not already pressed, then it's a new press and so we want to move at least one square
            if pressedkey != self.currentkey:
                self.keyqueue.append(pressedkey)
            # Remember that this key is pressed, so that if it is still held down more than a tick later, we continue moving as directed
	    self.currentkey = pressedkey
	except KeyError, e:
	    return

    def key_release_event(self, widget, event):
	try:
	    if self.currentkey == KMoveInput.keymap[event.keyval]:
		self.currentkey = None
	except KeyError, e:
	    return

    def mouse_motion_event(self, x, y):
        self.currentmouse = ("abs",x,y)

    def button_press_event(self, button, x, y):
	if button == 1:
	    self.mousemoving = True

    def button_release_event(self, button, x, y):
	if button == 1:
	    self.mousemoving = False

    def get_move(self):
	if len(self.keyqueue) > 0:
	    k = self.keyqueue[0]
	    self.keyqueue = self.keyqueue[1:]
	    return k
	if self.mousemoving and self.currentmouse:
	    return self.currentmouse
	return self.currentkey
